//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  lbg[N֘ANX
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/25
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  <WinSock2.h>
#include  <ws2tcpip.h>
#include  <iphlpapi.h>
#include  <Windows.h>
#include  <CommCtrl.h>
#include  <Process.h>
#include  <TChar.h>
#include  "NetworkNic.h"

//////////////////////////////////////////////////////////////////////
//        RXgN^/fXgN^
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  NetworkNic
//
//  @@@@\   :  RXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  g̃CX^X
//
//  @@   :  2020/ 3/25   by H.m
//////////////////////////////////////////////////////////////////////
NetworkNic::NetworkNic()
{
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  ~NetworkNic
//
//  @@@@\   :  fXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  Ȃ
//
//  @@   :  2020/ 3/25   by H.m
//////////////////////////////////////////////////////////////////////
NetworkNic::~NetworkNic()
{
}

//////////////////////////////////////////////////////////////////////
//        pubN\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  resolveAddress
//
//  @@@@\   :  w肳ꂽIPAhX(IPv4)MACAhX܂B
//
//  p[^   :  LPCTSTR  p_pctszIpAddresss  <- IPAhX
//                  LPTSTR   p_ptszMacAddress   -> MACAhX
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/25   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	NetworkNic::resolveAddress(LPCTSTR p_pctszIpAddresss, LPTSTR p_ptszMacAddress)
{
	CHAR	szIPAddress[MAX_PATH];

	// ANSIɕϊ
	WideCharToMultiByte(CP_ACP, 0, p_pctszIpAddresss, -1, szIPAddress, _countof(szIPAddress), NULL, NULL);

	// IPAhXϊ
	IPAddr IPAddress = inet_addr(szIPAddress);						// IP v4 ̂ݑΉ̂

	// ARPR}h𔭍sMACAhX擾
	MACADDR	macAddress;
	ULONG ulLen = sizeof(MACADDR);
	ZeroMemory(&macAddress, sizeof(MACADDR));
	DWORD dwResult = SendARP(IPAddress, NULL, (PULONG)&macAddress, &ulLen);
	if (dwResult != NO_ERROR) {
		return FALSE;
	}

	// MACAhX𕶎񐶐
	wsprintf(p_ptszMacAddress, _T("%02X:%02X:%02X:%02X:%02X:%02X"), macAddress.m_bAddress1, macAddress.m_bAddress2, macAddress.m_bAddress3, macAddress.m_bAddress4, macAddress.m_bAddress5, macAddress.m_bAddress6);

	return TRUE;
}

