//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  MAC2IP_CAONXwb_[
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/25
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#pragma once

//////////////////////////////////////////////////////////////////////
//        NX`
//////////////////////////////////////////////////////////////////////
class	IPMACClass	{
	HINSTANCE		m_hInstance;								// vOCX^X
	HWND			m_hWnd;									// EChEnh
public:
					IPMACClass(HINSTANCE p_hInstance);
					~IPMACClass();
	HINSTANCE		queryInstance()						{return m_hInstance;}
	IPMACClass*		getIPMACClass(HWND p_hWnd)		{return (IPMACClass*)GetWindowLongPtr(p_hWnd, GWLP_USERDATA);}
	LRESULT			wndProc(HWND p_hWnd, UINT p_uMessage, WPARAM p_wParam, LPARAM p_lParam);
	VOID			setTextEditBox(LPCTSTR p_pctszString);
private:
	LRESULT			wndProcCreate(HWND p_hWnd, LPARAM p_lParam);
	LRESULT			wndProcDestroy(HWND p_hWnd);
	LRESULT			wndProcCommand(HWND p_hWnd, UINT p_message, WPARAM p_wParam, LPARAM p_lParam);
	LRESULT			wndCommandMain(HWND p_hWnd);
	LRESULT			wndCommandDestroy(HWND p_hWnd);
	LRESULT			wndCommandAbout(HWND p_hWnd);
};
