//////////////////////////////////////////////////////////////////////
//  vWFNg  :  IP2MAC
//
//  t@C  :  bZ[WNX
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/25
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  <Windows.h>
#include  "Resource.h"
#include  "Message.h"

//////////////////////////////////////////////////////////////////////
//        G[bZ[W`
//////////////////////////////////////////////////////////////////////
MSGSTRUCT	ErrorMessage::m_msgTable[] =	{
	{IDS_APP_TITLE,	IDS_ERR_NOTINPUT, MB_ICONSTOP},	// MACAhX͂Ă܂(ERR_NOTINPUT)
	{IDS_APP_TITLE,	IDS_ERR_LENGTH,	MB_ICONSTOP},		// w肳ꂽMACAhX̒Ⴂ܂(ERR_LENGTH)
	{IDS_APP_TITLE,	IDS_ERR_NUMERIC,	MB_ICONSTOP},		// w肳ꂽMACAhXŐlȊO͂Ă܂(ERR_NUMERIC)
};

//////////////////////////////////////////////////////////////////////
//        pubN\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  errorMessage
//
//  @@@@\   :  G[bZ[W\B
//
//  p[^   :  HWND  p_hWndParent  <- eEChEnh
//                  int   p_nErrorCode  <- G[R[h
//
//  ߁@@l   :  int
//
//  @@   :  2020/ 3/25   by H.m
//////////////////////////////////////////////////////////////////////
int		ErrorMessage::dispErrorMessage(HWND p_hWndParent, int p_nErrorCode)
{
	TCHAR		tszTitle[MAX_PATH];
	TCHAR		tszMessage[MAX_PATH];

	HINSTANCE hInstance = (HINSTANCE)GetWindowLongPtr(p_hWndParent, GWLP_HINSTANCE);
	LoadString(hInstance, m_msgTable[p_nErrorCode].m_nMessage, tszTitle, MAX_PATH);
	LoadString(hInstance, m_msgTable[p_nErrorCode].m_nTitle, tszMessage, MAX_PATH);
	int nResult = MessageBox(p_hWndParent, tszMessage, tszTitle, m_msgTable[p_nErrorCode].m_nStyle);
	return nResult;
}
